/* options.h
 * File conversion package.  Peter Webb, Summer 1990.
 * Command line options table.  Lists all of the resources that the user can
 * modify on the command line.  Note that the table does not include the 
 * standard X modifiers (-geometry, -bc, etc), but only those specific to this 
 * program.  XtOpenDisplay knows about the standard X options.
 *
 * The format of each entry is as follows:
 *
 * cmd-line switch, resource name, option type, default value
 */

static XrmOptionDescRec options[] = {

/* Package specific options */

{"\-noGUI",        "*gui",                XrmoptionNoArg,   (caddr_t) "off"},
{"\-compress",     "*compress",           XrmoptionNoArg,   (caddr_t) "off"},
{"\-inputdir",     "*inputdir",           XrmoptionSepArg,  (caddr_t) NULL},
{"\-outputdir",    "*outputdir",          XrmoptionSepArg,  (caddr_t) NULL},

};
#define NUM_OPTIONS 4
